package li260.circuit;

import java.util.ArrayList;

import li260.geometrie.Vecteur;

public interface Circuit {

	  public Terrain getTerrain(int i, int j);
      public Terrain getTerrain(Vecteur v);

      public Vecteur getPointDepart();
      public Vecteur getDirectionDepart();
      public Vecteur getDirectionArrivee();
      public int getWidth();
      public int getHeight();
      public ArrayList<Vecteur> getArrivees();
      public double getDist(int i, int j); 
      public Terrain[][] getMatrix();
      public void changePix(Vecteur vecteur, Terrain herbe); 
      public boolean is_dans_circuit(Vecteur v);
}
