package li260.circuit;

import java.util.ArrayList;

import li260.geometrie.Vecteur;


public class CircuitImpl implements Circuit {
	private Terrain [] [] mat;
	private Vecteur dirDepart ;
	private Vecteur dirArrivee;
	  
	public CircuitImpl(Terrain[][] mat,Vecteur dep,Vecteur arr) {
		super();
		this.mat = mat;
		this.dirDepart = dep ;
		this.dirArrivee = arr ;
		//Filtre.filtre(mat);
	}

	public Terrain getTerrain(int i, int j){
		return mat[i][j];
	  }
	
    public Terrain getTerrain(Vecteur v) {
 
    	return mat[(int)v.getX()][(int)v.getY()];
    }

    public Vecteur getPointDepart() {
    	return CircuitFactoryFromFile.getDep();
    }
    
	public Vecteur getDirectionDepart() {
		return dirDepart;
	}

	public Vecteur getDirectionArrivee() {
		return dirArrivee;
	}
	
    public int getWidth() {
    
    	return mat.length ;
    }

    public int getHeight() {
    	return mat[0].length ;
    }
    
	
    public ArrayList<Vecteur> getArrivees() {
    	return  CircuitFactoryFromFile.getListe() ;
    }

    public Terrain[][] getMatrix() {
    	return mat ;
    }

	public double getDist(int i, int j) {
		return 0;
	}
	
	public void changePix(Vecteur v ,Terrain t){
	int	x =(int) v.getX();
	int y = (int) v.getY();
	if(y < this.getHeight()-5 && y > 0 &&   (x < this.getWidth() -5) && x > 5)
	this.mat[x][y] = t;
	}
	
	public boolean is_dans_circuit(Vecteur v){
			return (!((int)v.getX() < 0 || (int)v.getX() >= this.mat.length || (int)v.getY() < 0 || (int)v.getX() >= this.mat[0].length) );
	}
	
	
	
    		

}
