package li260.circuit;

import java.awt.Color;
import java.awt.image.BufferedImage;





public class TerrainTools {
	public static Terrain terrainFromChar(char c) throws TerrainException {
		switch (c) {
		case '.' : return Terrain.Route ; 
		case 'g' : return Terrain.Herbe ; 
		case 'b' : return Terrain.Eau ;
		case 'o' : return Terrain.Obstacle ;
		case 'r' : return Terrain.BandeRouge ;
		case 'w' : return Terrain.BandeBlanche ;
		case '*' : return Terrain.StartPoint ;
		case '!' : return Terrain.EndLine ;
		case 'm' : return Terrain.Boue ;
		default : throw new TerrainException("Le caractère ne représente aucun terrain ") ;
		}		
	}
	
	public static char charFromTerrain (Terrain c) {
		return Terrain.conversion[c.ordinal()] ;
		}
	
	public static Color terrainToRGB(Terrain c) {
		return Terrain.convColor[c.ordinal()] ;
		}
	
	public static boolean isRunnable(Terrain t){
		return ((t==Terrain.Route || t==Terrain.StartPoint || t==Terrain.EndLine || t==Terrain.BandeRouge || t==Terrain.BandeBlanche || t==Terrain.tram));
		}

	
	public static BufferedImage imageFromCircuit(Circuit circuit){
		Terrain[][] track = circuit.getMatrix();
		int x=track.length,y=track[0].length;
		System.out.println("x = "+x+" y = "+y);
	BufferedImage im = new BufferedImage(y,x, BufferedImage.TYPE_INT_ARGB);
	for(int i=0;i<x;i++){
			for(int j=0;j<y;j++){
				im.setRGB( j , i , TerrainTools.terrainToRGB(track[i][j]).getRGB());
			}
	}
	return im;	
	}
		
}
	

