package li260.dijkstra;

import java.util.ArrayList;
import java.util.Collections;

import li260.circuit.Circuit;
import li260.circuit.Terrain;
import li260.circuit.TerrainTools;
import li260.geometrie.Vecteur;
public class Dijkstra {
	private double[][] dest;
	private ArrayList<Vecteur> coord; 
	private Circuit c;
	private Vecteur current;
	private ComparatorDijk comp = new ComparatorDijk(dest);
	
	public double dmax;

	public Dijkstra(Circuit c ) {
		this.c = c;
		dest = new double[c.getWidth()][c.getHeight()];
		coord = new ArrayList<Vecteur>();
		for ( int i=0; i<  c.getWidth(); i++)
			for ( int j =0; j<c.getHeight();j ++)
				dest [i] [j] = Double.POSITIVE_INFINITY ;
		for (Vecteur p : c.getArrivees()){
			dest[(int ) p.getX ( )] [( int ) p.getY ( )] = 0 ;
			coord.add ( p ) ;
		}
		comp = new ComparatorDijk(dest);
		dmax =0;
		 optimize();
	}

	public void optimize(){
		Vecteur sens;
		double tmp;
		//Vecteur arrive = c.getDirectionArrivee();
	
		//int ti,tj;
		while(!(coord.isEmpty())){
			
			Collections.sort(coord,comp);
			current = Collections.min ( coord , comp ) ;
			coord.remove(current);
			// 
			for(int i=(int)current.getX()-1;i<=(int)current.getX()+1;i++){
				for(int j=(int)current.getY()-1;j<=(int)current.getY()+1;j++){

					if(dest[i][j] == 0) continue;
					if(i == (int)current.getX() && j == (int)current.getY()) continue;
					sens = (new Vecteur(i,j)).soustraction(current);

					
					if(sens.produitScalaire(c.getDirectionArrivee()) > 0 && c.getTerrain(current) == Terrain.EndLine) continue;
					//System.out.println("continue car sense vecto="+sens+"*"+c.getDirectionArrivee()+sens.produitVectoriel(c.getDirectionArrivee()));
					if(!TerrainTools.isRunnable(c.getTerrain(i, j)))	continue;

					tmp =dest[i][j];
					if(((current.getX() != i) && (current.getY() != j))) 
						dest[i][j] = Math.min(dest[i][j],dest[(int) current.getX()][(int) current.getY()]+14);
				
				else 
						dest[i][j] = Math.min(dest[i][j],dest[(int) current.getX()][(int) current.getY()]+10);
				
				if(tmp == Double.POSITIVE_INFINITY && dest[i][j] != Double.POSITIVE_INFINITY   )
					coord.add(new Vecteur(i,j));
				
				/*if(dest[i][j] != Double.POSITIVE_INFINITY){
						if(dmax < dest[i][j]){
								dmax = dest[i][j];
								ti = i;
								tj = j;
						}
				}*/
					}
				}

			}
	
	} 
		
	public double getDist(int x, int y) {

		return dest[x][y];
	}


}
