package li260.graphics;
import java.awt.BorderLayout;
import java.awt.Color;
import java.io.File;

import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import li260.outils.Bouton2Listener;
import li260.outils.BoutonAffichage;
import li260.outils.BoutonDijListener;
import li260.outils.BoutonListener;
import li260.outils.CircuitListener;
import li260.outils.VoituresListener;
public class Fenetre extends JFrame{


	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private JButton bouton = new JButton("Go");
	private JButton bouton2 = new JButton("Stop");
	private JButton bouton3 = new JButton("Dijkstra");
	private JButton mode = new JButton("Mode");
	private JPanel container = new JPanel();
	private JLabel labelc = new JLabel("Choisissez le Circuit :");
	private JLabel labelv = new JLabel("Nombre de voitures :");

	private Thread t;  
	private JComboBox<String> combo = new JComboBox<String>();
	private  JComboBox<Integer> nbvoiture = new JComboBox<Integer>();
	private Action pan;
	private File f;

	public Fenetre(Action p) {
		this.pan = p;
		this.setTitle("Animation");
		this.setSize(1500, 750);
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.setLocationRelativeTo(null);
		
		container.setBackground(Color.white);
		container.setLayout(new BorderLayout());
		container.add(pan, BorderLayout.CENTER);
		 
		bouton.addActionListener(new BoutonListener(this));
		bouton2.addActionListener(new Bouton2Listener(this));
		bouton2.addActionListener(new BoutonDijListener(this.getPan()));
		bouton2.setEnabled(false);    
		JPanel south = new JPanel();
		south.add(bouton);
		south.add(bouton2);
		south.add(bouton3);
		container.add(south, BorderLayout.SOUTH);
		f = new File("circuit/");
		combo = new JComboBox<String>(f.list());

		this.nbvoiture = new JComboBox<Integer>();
		for(int i=1 ; i<=10 ;i++){
			nbvoiture.addItem(i);
		}
		combo.addActionListener(new CircuitListener(this));
		this.nbvoiture.addActionListener(new VoituresListener(this));
		JPanel top = new JPanel();
		Box vbox = Box.createVerticalBox() ;
		top.add(vbox);
		mode.addActionListener(new BoutonAffichage(this));
		container.add(mode, BorderLayout.NORTH);

		vbox.add(labelc);
		vbox.add(combo);  
		vbox.add(labelv);
		vbox.add(nbvoiture);

		container.add(top, BorderLayout.EAST);
		this.setContentPane(container);
		this.setVisible(true);
		
	}
	
	/****************  Seters and Geters methods  ****************/
	public JButton getBouton() {
		return bouton;
	}
	public void setBouton(JButton bouton) {
		this.bouton = bouton;
	}
	public JButton getBouton2() {
		return bouton2;
	}
	public void setBouton2(JButton bouton2) {
		this.bouton2 = bouton2;
	}

	public void setContainer(JPanel container) {
		this.container = container;
	}
	public JComboBox<String> getCombo() {
		return combo;
	}
	public void setCombo(JComboBox<String> combo) {
		this.combo = combo;
	}
	public Action getPan() {
		return pan;
	}
	public void setPan(Action pan) {
		this.pan = pan;
	}

	public Thread getT() {
		return t;
	}
	public void setT(Thread t) {
		this.t = t;
	}

	public JComboBox<Integer> getNbvoiture() {
		return nbvoiture;
	}
	public void setNbvoiture(JComboBox<Integer> nbvoiture) {
		this.nbvoiture = nbvoiture;
	}

	/************************/


}
