package li260.outils;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.geom.AffineTransform;
import java.awt.image.AffineTransformOp;
import java.awt.image.BufferedImage;

import li260.circuit.Terrain;
import li260.geometrie.Vecteur;
import li260.graphics.Action;

public class Controleur implements ActionListener, MouseListener, MouseMotionListener{
	private Action pan;

	int currentMouseButton = -1;
	public Controleur(Action pan){
		this.pan  = pan;
	}


	@Override
	public void mouseClicked(MouseEvent e) {

		if( ! pan.isEvent())
			return ;

		if(e.getButton() == 1 )  {
			if(pan.getDanger() == null) return ;
			this.pan.getDanger().add(new Vecteur(e.getY(), e.getX()));
			for(int i=-5;i<5;i++){
				for(int j=-5;j<5;j++){
					Graphics2D g = (Graphics2D) pan.getIm().getGraphics();
					g . setColor ( Color.red ) ;
					g.drawOval(e.getX()+i , e.getY()+j  , 0 ,0);
					e . getComponent ( ).repaint() ;
				}
			}
		}

		else {

			if(pan.getIm() != null) {
				Graphics2D g = (Graphics2D) pan.getIm().getGraphics();

				g.setFont ( new Font ( " t i m e " , 1 , 18 ) ) ;
				g . setColor ( Color . blue ) ;

				g.drawOval(e.getX() - 4, e.getY( ) + 4 , 8 ,8);
				e . getComponent ( ).repaint() ;
			}
			pan.getPoints().add(new Vecteur(e.getY(),e.getX() ));
		}


	}


	@Override
	public void mousePressed(MouseEvent e) {
		// TODO Auto-generated method stub 
	}


	@Override
	public void mouseReleased(MouseEvent e) {
		// TODO Auto-generated method stub
		currentMouseButton = -1;
	}

	@Override
	public void mouseEntered(MouseEvent e) {
		// TODO Auto-generated method stub
	}

	@Override
	public void mouseExited(MouseEvent e) {
		// TODO Auto-generated method stub
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		// TODO Auto-generated method stub

	}

	@Override
	public void mouseDragged(MouseEvent e) {
		// TODO Auto-generated method stub
		if(! pan.isEvent()) 
			return ;
		Graphics2D g = (Graphics2D) pan.getIm().getGraphics();

		for(int i=-5;i<10;i++){
			for(int j=-5;j<10;j++){

				pan.getCircuit().changePix(new Vecteur(e.getY()+i,e.getX()+j),Terrain.Herbe);

				g . setColor ( Color.green ) ;
				g.drawOval(e.getX()+i , e.getY()+j  , 0 ,0);
				e . getComponent ( ).repaint() ;
			}
		}


	}

	@Override
	public void mouseMoved(MouseEvent e) {
		// TODO Auto-generated method stub

	}

	public static BufferedImage changeDim(BufferedImage img,double x){

		BufferedImage img2 = new BufferedImage((int)(img.getWidth()*x),(int)( img.getHeight()*x), img.getType());
		AffineTransform reduire = AffineTransform.getScaleInstance(x, x);
		int interpolation = AffineTransformOp.TYPE_BICUBIC;
		AffineTransformOp retaillerImage = new AffineTransformOp(reduire, interpolation);
		retaillerImage.filter(img, img2 );
		return img2;
	}

}
