package li260.radar;


import li260.circuit.Circuit;
import li260.circuit.Terrain;
import li260.circuit.TerrainTools;
import li260.geometrie.Vecteur;
import li260.voiture.Voiture;
public class RadarClassique implements Radar{


	private Circuit c;
	private Voiture v;
	private double[] theta; 
	private int index;
	private double[] distPix;
	private boolean arriv_visible = false;

	public RadarClassique(Circuit c, Voiture v , double[] theta) {
		super();
		this.c = c;
		this.v = v;
		this.theta = theta;
		this.distPix = new double[theta.length];
	}


	private double scoreI(double angle){
		Vecteur p= v.getPosition().clonage();
		Vecteur d= (v.getDirection().clonage()).rotation(angle);
		double cpt=0;

		while (TerrainTools.isRunnable(c.getTerrain(p)) &&  c.is_dans_circuit(p)){
			cpt++;
			p=p.addition(d.multParUnScalaire(0.1));

			if(d.produitScalaire(c.getDirectionArrivee())<0 && c.getTerrain(p) == Terrain.EndLine)
				return -5;
		}
		return cpt;	
	}

	@Override
	public double[] scores() {
		if(c.getTerrain(v.getPosition()) == Terrain.EndLine ){
			System.out.println("FIN");
			if((v.getDirection().produitScalaire(c.getDirectionArrivee())>=0)){
				v.gagne(true);
				return null;
			}
			else {
				v.echec(true);
				return null;
			}
		}
		double tmp =-1. ;
		double[] scores = new double [theta.length];
		for (int i=0;i<theta.length;i++){
			scores[i]= scoreI(theta[i]);
			if(scores[i] == Double.POSITIVE_INFINITY)
				distPix[i] = 0;	
			else distPix[i] = scores[i]/10;
			if(		scores[0] == 0 && scores[1] ==0 && scores[2] == 0 &&
					scores[3] == 0 && scores[4] == 0 && scores[5] == 0 && 
					scores[6] == 0 &&scores[7] == 0 && scores[8] == 0){ // echec pour tous les faisceaux   
				v.echec(true);
				return null;
			}
			if( (scores[i] == Double.POSITIVE_INFINITY) &&  i == 4 ){
				index = 4;
				break;
			}


			if (tmp < scores[i]) {
				tmp = scores[i];
				index = i;
			}
		}
		return scores;
	}

	@Override
	public double[] distancesInPixels() {

		return distPix;
	}

	@Override
	public int getBestIndex() {

		return index;
	}

	@Override
	public double[] thetas() {
		return theta;
	}


	@Override
	public Voiture getVoiture() {
		return v;
	}


	@Override
	public boolean isArriv_visible() {

		return arriv_visible;
	}



}
