package li260.radar;

import li260.circuit.Circuit;
import li260.circuit.Terrain;
import li260.dijkstra.Dijkstra;
import li260.geometrie.Vecteur;
import li260.voiture.Voiture;

public class RadarDijkstra implements Radar{



	private Circuit c;
	private Voiture v;
	private double[] theta;
	private int cpti;
	private double[] distPix;
	private int index;
	private Dijkstra dij;
	@SuppressWarnings("unused")
	private int cpt ;
	private boolean arriv_visible = false;





	public RadarDijkstra(Circuit c, Voiture v, double[] theta,Dijkstra d) {
		super();
		this.c = c;
		this.v = v;
		this.theta = theta;
		distPix = new double[theta.length];
		this.dij = d ;
	}


	private double scorei(double angle){

		Vecteur p= v.getPosition().clonage();
		@SuppressWarnings("unused")
		Vecteur tmp= v.getPosition().clonage();
		Vecteur d= (v.getDirection().clonage()).rotation(angle);
		cpt = cpti;
		cpti=0;

		double min= Double.POSITIVE_INFINITY ;
		while (c.getTerrain(p) != Terrain.Herbe && (dij.getDist((int)p.getX(), (int)p.getY()) != Double.POSITIVE_INFINITY)){
			if(min > dij.getDist((int)p.getX(), (int)p.getY()))
				min = dij.getDist((int)p.getX(), (int)p.getY());
			p=p.addition(d.multParUnScalaire(0.01));
			cpti++;
			if(c.getTerrain(p) == Terrain.EndLine){
				this.arriv_visible = true;
				if(d.produitScalaire(c.getDirectionArrivee())<0) 
					return Double.POSITIVE_INFINITY;
				else
					return -1e6+cpti;
			}
		}

		//		if(k == 1 ) <= 0) 
		//		if (k == 1 ) return -5;
		return min;	
	}

	@Override
	public double[] scores() {
		double tmp =Double.POSITIVE_INFINITY ;
		double[] scores = new double [theta.length];
		if(c.getTerrain(v.getPosition()) == Terrain.EndLine ){
			if((v.getDirection().produitVectoriel(c.getDirectionArrivee()) >= 0)){
				v.gagne(true);
				return null;
			}
			else {
				v.echec(true);
				return null;
			}
		}
		for (int i=0;i<theta.length;i++){
			scores[i]= scorei(theta[i]);
			distPix[i] = cpti/100;

			if( (scores[i] == 0) &&  theta[i] == theta[4] ){
				index = 4;
				System.out.println("index");
				break;
			}
			if (tmp > scores[i]) {
				tmp = scores[i];
				index = i;
			}
		}

		if(scores[index] == Double.POSITIVE_INFINITY ){
			v.echec(true);
			return null;
		}

		return scores;
	}
	@Override
	public double[] distancesInPixels() {

		return distPix;
	}

	@Override
	public int getBestIndex() {

		return index;
	}

	@Override
	public double[] thetas() {
		return theta;
	}

	@Override
	public Voiture getVoiture() {

		return this.v;
	}


	public boolean isArriv_visible() {
		return arriv_visible;
	}


	public void setArriv_visible(boolean arriv_visible) {
		this.arriv_visible = arriv_visible;
	}

}
