package li260.radar;

import li260.circuit.Circuit;
import li260.circuit.Terrain;
import li260.circuit.TerrainTools;
import li260.geometrie.Vecteur;
import li260.voiture.Voiture;

public class RadarTram implements Radar {

	private Circuit c;
	private Voiture v;
	private double[] theta; 
	private int index;
	//private double[] distPix;

	public RadarTram(Circuit c, Voiture v , double[] theta) {
		super();
		this.c = c;
		this.v = v;
		this.theta = theta;

		//this.distPix = new double[theta.length];
	}

	private double scorei(double angle){

		Vecteur p= v.getPosition().clonage();
		if(!TerrainTools.isRunnable(c.getTerrain(p))){
			v.echec(true);
			return 0;
		}
		Vecteur d= (v.getDirection().clonage()).rotation(angle);
		//while(TerrainTools.isRunnable(c.getTerrain(p))){
		for(int i=0;i<30;i++){
			p=p.addition(d.multParUnScalaire(1));
			if (c.getTerrain(p) == Terrain.tram) return 1;
		}
		return 0;
	}

	@Override
	public double[] scores() {
		index = -1;
		double[] scores = new double [theta.length];
		for(int i=0;i<theta.length;i++){
			scores[i] = scorei(theta[i]);
			if(scores[i] == 1){
				//if(index == -1 )
				index = i;
				//else if(theta[i] <= theta[index])
				//	index = i;
			}
		}
		if(index == 1) System.out.println("index == "+index);
		return scores;
	}

	@Override
	public double[] distancesInPixels() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public int getBestIndex() {
		return index;
	}

	@Override
	public double[] thetas() {
		return theta;
	}

	@Override
	public Voiture getVoiture() {
		return v;
	}

	@Override
	public boolean isArriv_visible() {
		// TODO Auto-generated method stub
		return false;
	}

}
