package li260.simulation;



import java.awt.Color;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import javax.imageio.ImageIO;
import li260.circuit.Circuit;
import li260.circuit.TerrainTools;
import li260.strategy.Strategy;
import li260.strategy.StrategyListeCommande;
import li260.updateEventListener.UpdateEventListener;
import li260.updateEventSender.UpdateEventSender;
import li260.voiture.Commande;
import li260.voiture.Voiture;
import li260.voiture.VoitureException;


public class SimulationImpl implements Simulation, UpdateEventSender {
	private ArrayList<Voiture> voitures;
	private ArrayList<Strategy> strs;
	BufferedImage im ;
	private ArrayList<StrategyListeCommande> record;
	ArrayList<UpdateEventListener> listeners;
	private boolean simulation = true;
	int i=0;




	public void setRecord(ArrayList<StrategyListeCommande> record) {
		this.record = record;
	}



	public void setIm(BufferedImage im) {
		this.im = im;
	}

	public SimulationImpl(ArrayList<Voiture> voitures, Circuit c,ArrayList<Strategy> strs) {
		super();
		this.voitures = voitures;
		this.strs = strs;
		this.im =  TerrainTools.imageFromCircuit(c);
		record= new ArrayList<StrategyListeCommande>();
		this.listeners = new ArrayList<UpdateEventListener>();
	}

	@Override
	public void play() throws VoitureException, IOException {

		Commande a =null; 
		for(int i=0;i<voitures.size();i++)	{
			record.add(new StrategyListeCommande(new ArrayList<Commande>()));
		}
		System.out.println("depart");
		while(!this.fin_course()){

			if(simulation == false) return;
			for(int j=0 ;j<voitures.size();j++){
				a = strs.get(j).getCommande();
				if(voitures.get(j).isechec() ) continue;
				if(a == null){
					voitures.get(j).echec(true);
					continue;
				}
				record.get(j).add(a);
				for(int k=-1;k<=1;k++){
					for(int m=-1;m<=1;m++)
						im.setRGB((int)voitures.get(j).getPosition().getY()+m, (int)voitures.get(j).getPosition().getX()+k, Color.blue.getRGB());
				}
				voitures.get(j).drive(a);
				voitures.get(j).ok();
				i++;

			}

			this.update();
		}
		reset_record();
	}

	public void saveImage() throws IOException{
		ImageIO.write(this.im, "png", new File("test.png"));
	}

	public void afficher () {

		for(int i=0;i<voitures.size();i++){
			if(voitures.get(i).isgagne()){
				System.out.println("\t\t *******  Voiture numero "+i+" :  Arrive  a  :   "+voitures.get(i).myscors()+" *****\n");
			}
			else {
				System.out.println("\t\t *******  Voiture numero "+i+" :  Echecs  a  :   "+voitures.get(i).myscors()+" *****\n");
			}
		}
	}

	public boolean fin_course(){
		for(Voiture v:voitures){
			if(!v.isechec()) return false;
		}
		return true;
	}
	//pour metre tour les indexs des liste record en 0
	public void reset_record(){
		for(StrategyListeCommande a:record){
			a.init();
		}

	}

	public ArrayList<StrategyListeCommande> getRecord() {
		return record;
	}

	@Override
	public void playOneShot() {
		// TODO Auto-generated method stub

	}
	@Override
	public void add(UpdateEventListener listener) {
		listeners.add(listener);
	}

	@Override
	public void update() {
		for (int i=0;i<listeners.size();i++){
			listeners.get(i).manageUpdate();
		}

	}
	public boolean isSimulation() {
		return simulation;
	}

	public void setSimulation(boolean simulation) {
		this.simulation = simulation;
	}

}
