package li260.strategy;

import java.util.ArrayList;

import li260.circuit.Circuit;
import li260.dijkstra.Dijkstra;
import li260.geometrie.Vecteur;
import li260.radar.Radar;
import li260.radar.RadarDijkstra;
import li260.voiture.Commande;
import li260.voiture.Voiture;

public class StrategyComposite implements Strategy {
	private ArrayList<Strategy> strs ;
	private ArrayList<Selector> selects;
	public StrategyComposite(){
		this.strs = new ArrayList<Strategy>();
		this.selects = new ArrayList<Selector>();
	}
	
	
	
	
	
	public void add(Strategy str,Selector select){
		strs.add(str);
		selects.add(select);
	}
	
	@Override
	public Commande getCommande() {
		
	for(int i=0;i<strs.size();i++){
		if(selects.get(i).isSelected() == true){
		
				return strs.get(i).getCommande();
			}
		}
	return strs.get(strs.size()-1).getCommande();
	
	}
	
	
	
	
	
	
	
	
	
	
	public static void genererComposite(Circuit c,Voiture v,ArrayList<Vecteur> points,ArrayList<Radar> r,double[] theta,StrategyComposite strCompo,double x,Dijkstra d,ArrayList<Vecteur> danger){
		   Strategy tmp1,tmp2,tmp3; // tmp1:Strategie Dijkstra
		   							// tmp2:Strategie Point a Point
		   							// tmp3:Strategie Prudente
		   SelectorImpl select1,select2,select3;

		r.add( new RadarDijkstra(c,v,theta,d));
		tmp1 = new StrategyRadar(r.get(r.size()-1),v);
		select1 = new SelectorImpl(tmp1);
		   
		   
		tmp2 = new StrategyPoint2(c,v,points);
		select2 = new SelectorImpl(tmp2);
		
		tmp3 = new StrategyPrudente(tmp1, v, c, r.get(r.size()-1),x,danger);
		select3 = new SelectorImpl(tmp3);
		
		strCompo.add(tmp3, select3);
		strCompo.add(tmp2, select2);
		strCompo.add(tmp1, select1);
	}

}
