package li260.strategy;

import java.util.ArrayList;

import li260.circuit.Circuit;
import li260.circuit.TerrainTools;
import li260.geometrie.Vecteur;
import li260.voiture.Commande;
import li260.voiture.Voiture;

public class StrategyPoint implements Strategy {

	Circuit c ;
	Voiture v;
	ArrayList<Vecteur> points;
	public StrategyPoint(Circuit c,Voiture v,ArrayList<Vecteur> points) {
		super();
		this.c = c;
		this.v = v; 
		this.points = points;
	}






	@Override
	public Commande getCommande() {

		Vecteur A = null;


		if(points.size() == 0)
			return null;

		if(StrategyPoint.isVisible(v.getPosition(), points.get(0), c))A = points.get(0);

		if(A == null){
			System.out.println(A);	
			return null;
		}

		Vecteur PA = A.soustraction(v.getPosition());
		if(PA.norme() < 1){
			points.remove(0);	
			return null;
		}

		double theta =  v.getDirection().angle(PA);


		return new Commande (v.combien_acc(Math.abs(theta)),-v.combienTurn(theta));

	}


	public static boolean isVisible(Vecteur V,Vecteur A,Circuit c){
		Vecteur P = V.clonage();
		Vecteur PA = A.soustraction(P);
		PA.toUnitVec();
		while(A.soustraction(P).norme() > 1){
			P = P.addition(PA.multParUnScalaire(0.1));
			if(!TerrainTools.isRunnable(c.getTerrain(P)) )
				return false;
		}
		return true;
	}





}
