package li260.strategy;

import java.util.ArrayList;

import li260.circuit.Circuit;
import li260.circuit.TerrainTools;
import li260.geometrie.Vecteur;
import li260.voiture.Commande;
import li260.voiture.Voiture;

public class StrategyPoint2 implements Strategy {


	Circuit c ;
	Voiture v;
	ArrayList<Vecteur> points;
	int  i= 0;
	public StrategyPoint2(Circuit c,Voiture v,ArrayList<Vecteur> points) {
		super();
		this.c = c;
		this.v = v; 
		this.points = points;
	}






	@Override
	public Commande getCommande() {
		// TODO Auto-generated method stub
		Vecteur A = new Vecteur(0,0);
		ArrayList<Vecteur> visible = new ArrayList<Vecteur>();
		Vecteur tmp1;
		for(Vecteur point:points){
			if(StrategyPoint.isVisible(v.getPosition(), point, c)){
				tmp1 = point.soustraction(v.getPosition());
				if(v.getDirection().produitScalaire(tmp1) > 0)
					visible.add(point);
			}
		}

		if(visible.isEmpty()) return null;
		if(visible.size() == 1) A = visible.get(0);

		else{
			double max = -1,tmp;
			int j;
			for(Vecteur point:visible){
				tmp = Math.abs((point.soustraction(v.getPosition())).norme());

				if(tmp > max){
					j = chercheVect(A);
					if(j != -1)
						points.remove(j);
					A = point;
					max = tmp;
				}

			}
		}

		Vecteur PA = A.soustraction(v.getPosition());
		if(PA.norme() < 1){
			points.remove(A);
			return null;
		}


		double theta =  v.getDirection().angle(PA);
		theta = theta / v.getBraquage();


		return new Commande (v.combien_acc(Math.abs(theta)),-v.combienTurn(theta));

	}


	public static boolean isVisible(Vecteur V,Vecteur A,Circuit c){
		Vecteur P = V.clonage();
		Vecteur PA = A.soustraction(P);
		PA.toUnitVec();
		while(A.soustraction(P).norme() > 1){
			P = P.addition(PA.multParUnScalaire(0.1));
			if(!TerrainTools.isRunnable(c.getTerrain(P)))
				return false;
		}
		return true;
	}

	public int chercheVect(Vecteur v){
		for(int i=0;i<points.size();i++){
			if((v.getX() == points.get(i).getX()) && (v.getY() == points.get(i).getY())){
				return i;
			}
		}
		return -1;
	}



}
