package li260.view.observeurs;

import java.awt.Color;
import java.awt.Graphics;

import li260.geometrie.Vecteur;
import li260.radar.Radar;
import li260.swing.ObserveurSWING;
import li260.voiture.Voiture;

public class RadarObserver implements ObserveurSWING{

	private Radar r;
	private Voiture voiture;
	private Color color;

	public RadarObserver(Voiture voiture,Radar r,Color color) {
		this.r = r;
		this.voiture = voiture;
		this.color = color; 
	}

	@Override
	public void print(Graphics g) {
		Vecteur p,d2,e;
		Vecteur d = voiture.getDirection().clonage();
		if(voiture.isechec()) return;
		for(int i=0;i<r.thetas().length;i++){
			g.setColor(color);
			d2 = d.rotation(r.thetas()[i]);
			p = voiture.getPosition().clonage();
			e = p.addition(d2.multParUnScalaire(r.distancesInPixels()[i]));
			if(i == r.getBestIndex()) g.setColor(Color.BLUE);
			g.drawLine(this.getX(),this.getY(),(int)e.getY()  , (int) e.getX());
		}
	}

	public int getY(){ // a inverser pour l'affichage horizontal
		return (int) voiture.getPosition().getX();
	}
	public int getX(){
		return (int) voiture.getPosition().getY();
	}

}
