package li260.view.observeurs;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.image.BufferedImage;

import li260.swing.ObserveurSWING;
import li260.voiture.Voiture;

public class VoitureObserver implements ObserveurSWING {
	private Voiture voiture;
	private Color color = Color.yellow;

	public VoitureObserver(Voiture voiture,Color color) {
		this(voiture);
		this.color = color; 
	}
	// couleur de la voiture par d�faut : jaune 
	public VoitureObserver(Voiture voiture) {
		super();
		this.voiture = voiture; 
	}
	public int getY(){ // a inverser pour l'affichage horizontal
		return (int) voiture.getPosition().getX();
	}
	public int getX(){
		return (int) voiture.getPosition().getY();
	}

	public Color getColor() {
		if(voiture.getVitesse()<0.3) // vitesse faible -> cyan
			return new Color(0, (int)(voiture.getVitesse()*255*2), (int) (voiture.getVitesse()*255*2));

		if(voiture.getVitesse() == 0.9)
			return new Color((int)(voiture.getVitesse()*255),  (int) (voiture.getVitesse()*255), 0);

		return new Color((int)(voiture.getVitesse()*255), 0, (int) (voiture.getVitesse()*255));
	}

	public void print(BufferedImage im) {
		im.setRGB(getX(), getY(), getColor().getRGB());
	}
	public void print(Graphics g){
		// Attention a l'inversion eventuelle des coordonnees
		g.setColor(color);
		g.drawRect(this.getX(), this.getY(), 2, 2);
		g.setColor(Color.red);
		g.drawLine(this.getX(),
				this.getY(),
				(int)(this.getX()+voiture.getDirection().getY()*10),
				(int) (this.getY()+voiture.getDirection().getX()*10));

		g.setColor(Color.blue);

		if(voiture.isechec() && !voiture.isgagne()){
			g.setColor(Color.red);
			g.setFont(new Font(" TimesRoman ",Font.BOLD,20));
			g.drawString(String.format("voiture %d (%s): %d Echec",voiture.get_num(),voiture.getStrategyv(),voiture.myscors()),
					5 , (voiture.get_num()+1)*15 );
			return;
		}
		g.setFont(new Font(" TimesRoman ",Font.BOLD,20));
		// g.drawString(String.format("v: %.2f d: (%6.2f, %6.2f) derap: ", voiture.getVitesse(),
		//   this.getX(), this.getY()),
		//    10, 10+10*voiture.get_num());
		g.drawString(String.format("voiture %d (%s): %d v %.2f",voiture.get_num(),voiture.getStrategyv(),voiture.myscors(),voiture.getVitesse()*100),
				5 , (voiture.get_num()+1)*15 );

		g.drawString(String.format("%d",voiture.get_num()),
				this.getX(), this.getY());
	}
}

