package li260.view.observeurs;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.geom.AffineTransform;
import java.awt.image.AffineTransformOp;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;

import li260.geometrie.Vecteur;
import li260.swing.ObserveurSWING;
import li260.voiture.Voiture;

public class VoitureObserver2 implements ObserveurSWING{


	private Voiture voiture;
	private BufferedImage car;
	public VoitureObserver2(Voiture voiture,Color color) throws IOException {
		this(voiture); 
	}

	// couleur de la voiture par d�faut : jaune 
	public VoitureObserver2(Voiture voiture) throws IOException {
		super();
		this.voiture = voiture; 
		this.car = ImageIO.read(new File("Alexis2.png"));
	}


	public int getY(){ // a inverser pour l'affichage horizontal
		return (int) voiture.getPosition().getX();
	}
	public int getX(){
		return (int) voiture.getPosition().getY();
	}	

	@Override
	public void print(Graphics g) {


		int 	signe =(voiture.getDirection().signe(new Vecteur(0, 1)))==true?1:-1;	

		double angle = Math.PI/2 - signe *-1* voiture.getDirection().angle(new Vecteur(0, 1));


		// construction d'une transformation
		AffineTransform transform = new AffineTransform();
		// rotation par rapport à un centre à définir (cf javadoc)
		transform.rotate(angle, (car.getWidth() / 2), (car.getHeight() / 2));
		// transformation => transformation d'image
		AffineTransformOp op = new AffineTransformOp(transform, AffineTransformOp.TYPE_BICUBIC);

		// image finale
		BufferedImage carMod = op.filter(car, null);

		g.drawImage(carMod, this.getX() - 30, this.getY() - 30, null);

	}		}
