package li260.voiture;

import li260.geometrie.Vecteur;

public class VoitureImpl implements Voiture {
	private int num;
	private double vmax ;
	private  double alpha_c ;
	private  double braquage;
	private  double alpha_f ;
	private  double beta;
	private  double[] tabVitesse  ;
	private double[] tabTurn    ;
	private  double vitesse;
	private Vecteur direction ;
	private Vecteur position ;
	private boolean echec;
	private int myscore;
	private boolean gagner;
	private String strategyv = "Strategy Classique";

	public VoitureImpl(Vecteur position, Vecteur direction, double vmax, double alpha_c, double braquage,double alpha_f, double beta, double[] tabVitesse, double[] tabTurn,double vitesse,int num) {
		super();
		this.num = num;
		this.vmax = vmax;
		this.alpha_c = alpha_c;
		this.braquage = braquage;
		this.alpha_f = alpha_f;
		this.beta = beta;
		this.tabVitesse = tabVitesse;
		this.tabTurn = tabTurn;
		this.vitesse = vitesse;
		this.position = position;
		this.direction = direction;
		this.echec =false;
		this.myscore = 0;
		this.gagner = false;
	}

	@Override
	public void drive (Commande c) throws VoitureException {

		if (!(c.getTurn() <= 1 && c.getTurn() >= -1 && c.getAcc() <=1 && c.getAcc() >=-1))  throw new VoitureException("Commande non admissible") ;
		if (this.getMaxTurn() < Math.abs(c.getTurn ())) {
			System.out.println(c);
			throw new VoitureException("Commande rotation non admissible") ;
		}
		/*if (c.getTurn() > this.getMaxTurn()) 
			direction.autoRotation(this.getMaxTurn()*braquage);
		else*/
		direction.autoRotation(c.getTurn()*braquage) ; 

		vitesse -= alpha_f;
		vitesse -= beta*vitesse;

		vitesse += c.getAcc() * alpha_c;

		// 2.3) garanties, bornes...
		direction.toUnitVec();

		vitesse = Math.max(0., vitesse); // pas de vitesse négative
		vitesse = Math.min(vmax,vitesse);

		// 3) mise à jour de la position
		if(Double.isNaN(direction.getX())){
			System.out.println(c + " " +vitesse);
			throw new VoitureException("PROBELME DIRECTION") ;
		}
		position.autoAddition(direction.multParUnScalaire(vitesse));

		if(Double.isNaN(position.getX())){
			System.out.println(c + " " +vitesse);
			throw new VoitureException("PROBELME") ;
		}
	}

	@Override
	public double getMaxTurn() {
		for(int i=0;i<tabTurn.length;i++){
			if(this.vitesse < tabVitesse[i])
				return tabTurn[i];
		}

		return 0;
	}

	@Override
	public double getVmax() {
		return vmax;
	}

	@Override
	public double getVitesse() {
		return vitesse;
	}

	@Override
	public Vecteur getPosition() {
		return position;
	}

	public Vecteur getPositionClone() {
		return position.clonage();
	}



	@Override
	public Vecteur getDirection() {
		return direction;
	}

	@Override
	public double getBraquage() {
		return braquage;
	}

	@Override
	public double combienTurn(double angle) {
		angle = Math.min(angle,this.getMaxTurn());
		angle = Math.max(angle,-this.getMaxTurn());
		return angle;
	}
	public double apres_dec(double acc){
		double v = vitesse;
		v -= alpha_f;
		v -= beta*v;

		v += acc * alpha_c;


		v = Math.max(0., v); // pas de vitesse n�gative
		v = Math.min(vmax,v);
		return v;
	}

	public double combien_acc(double angle){

		double a = angle / this.braquage ;
		double ratio = a /this.getMaxTurn();

		if(ratio <= 5) return 0.4;
		if(ratio <= 10) return 0;
		else return -1;

	}








	@Override
	public void echec(boolean e) {
		echec = e;
	}

	@Override
	public boolean isechec() {
		return echec;
	}

	@Override
	public void ok() {
		this.myscore++;

	}

	@Override
	public int myscors() {
		return myscore;
	}

	@Override
	public void gagne(boolean e) {
		this.gagner = e;

	}

	@Override
	public boolean isgagne() {
		return gagner;
	}

	@Override
	public int get_num() {
		return num;
	}

	public String getStrategyv() {
		return strategyv;
	}

	public void setStrategyv(String strategyv) {
		this.strategyv = strategyv;
	}



}
